var rodeo = rodeo || {};

rodeo.rodeoWeatherSetup = (function (el) {
    var format_css, layout_type, main_container, container;

    // get specifics from the respond system to send off to the api
    layout_type = el.getAttribute('layout_type');

    format_css = el.getAttribute('format_css');

    if (format_css === null) {
    } else {
        var link = $("<link />", {
            rel: "stylesheet",
            type: "text/css",
            href: format_css
        })
        $('#weather-plugin').append(link);
    }

    if (layout_type === "simple") {
        main_container = el.querySelector('#template_hunt-weather-simple');
        container = el.querySelector('#weather-info');
        rodeo.rodeoSimpleWeather(container, main_container);
    } else {
        main_container = el.querySelector('#template_hunt-weather_ten_days');
        container = el.querySelector('#ten-days-weather');
        rodeo.rodeo10DaysWeather(container, main_container);
    }
});

rodeo.rodeo10DaysWeather = (function (container, main_container) {
    $.ajax({
        url: "//api.wunderground.com/api/0a85d029aa658f31/forecast10day/q/pws:KORHILLS164.json",
        dataType: "jsonp",
        success: function (parsed_json) {
            if (parsed_json && parsed_json != "" && parsed_json != undefined) {
                var theader = [];
                var tbody = [];
                $.each(parsed_json["forecast"]["simpleforecast"]["forecastday"], function (index, forcast) {
                    theader.push("<td>" + forcast["date"]["weekday_short"] + " " + forcast["date"]["month"] + "/" + forcast["date"]["day"] + "</td>");
                    var first_column = "<span class='red'>" + forcast["high"]["fahrenheit"] + "°" + "</span> | <span class='blue'>" + forcast["low"]["fahrenheit"] + "°</span> F"
                    var second_column = "<br/><img src='" + forcast["icon_url"] + "'/><br/>" + forcast["conditions"];
                    var wet = "";
                    if (forcast["qpf_day"]["in"] > 0) {
                        wet = "wet";
                    }
                    var third_column = "<br/><div class=\"cond-qpf\">" +
                            "<span class=\"icon-qpf " + wet + "\" title=\"pop\"></span>" + forcast["qpf_day"]["in"] + " in" +
                            "</div>";
                    tbody.push(
                            "<td>" + first_column + second_column + third_column + "</td>"
                            );
                });
                $(container).html("<thead><tr>" + theader.join("") + "</tr></thead>" +
                        "<tbody><tr>" + tbody.join("") + "</tr></tbody>"
                        );
                $(main_container).removeClass("gr-hide");
            } else {
                alert("Coult not call weather api");
            }
        }
    });
});

rodeo.rodeoSimpleWeather = (function (container, main_container) {
    $.ajax({
        url: "//api.wunderground.com/api/0a85d029aa658f31/conditions/q/pws:KORHILLS164.json",
        dataType: "jsonp",
        success: function (parsed_json) {
            if (parsed_json && parsed_json != "" && parsed_json != undefined) {
                $(container).find("#temp").html(parsed_json["current_observation"]["temp_c"] + "°C");
                $(container).find("#location").html(parsed_json["current_observation"]["display_location"]["full"]);
                $(container).find("#wind").html("Wind: " + parsed_json["current_observation"]["wind_kph"] + "kph (WSW)");
                $(container).find("#humadity").html("Humadity: " + parsed_json["current_observation"]["relative_humidity"]);
                $(container).find("#summary").html("Summary: " + parsed_json["current_observation"]["weather"]);
                $(container).find("#weather-icon").html("<img src='" + parsed_json["current_observation"]["icon_url"] + "' />");
                $(main_container).removeClass("gr-hide");
            } else {
                alert("Coult not call weather api");
            }
        }
    });
});
